%define		gitver 67e3510
Summary:	C library intended for use on embedded systems
Name:		crossnacl-newlib
Version:	1.20.0
Release:	1.git%{gitver}
License:	BSD and MIT and LGPL v2+
Group:		Libraries
Source0:	nacl-newlib-%{version}-git%{gitver}.tar.bz2
# Source0-md5:	62471478377d5f99a2ce88213731e500
Source1:	nacl-headers-21.0.1180.57.tar.bz2
# Source1-md5:	8e76cde640c1f268e14dbd67568a4bee
# Taken from chromium-15.0.874.106/native_client/tools/newlib-libc-script
Source2:	newlib-libc-script
Source3:	pthread.h
Source4:	get-source.sh
URL:		http://sourceware.org/newlib/
BuildRequires:	crossnacl-binutils
BuildRequires:	crossnacl-gcc
BuildRequires:	fslint
ExclusiveArch:	%{ix86} %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		target		x86_64-nacl

%description
Newlib is a C library intended for use on embedded systems. It is a
conglomeration of several library parts, all under free software
licenses that make them easily usable on embedded products.

This is the nacl fork.

%prep
%setup -q -n nacl-newlib-%{version}-git%{?gitver}
tar -xvf %{SOURCE1} -C newlib/libc/sys/nacl --strip-components=1
cp -p %{SOURCE2} .

%build
export NEWLIB_CFLAGS="-O2 -D_I386MACH_ALLOW_HW_INTERRUPTS -DSIGNAL_PROVIDED -mtls-use-call"
%configure \
	--disable-libgloss \
	--enable-newlib-iconv \
	--enable-newlib-io-long-long \
	--enable-newlib-io-long-double \
	--enable-newlib-io-c99-formats \
	--enable-newlib-mb \
	libc_cv_initfinit_array=yes \
	CFLAGS="-O2" \
	CFLAGS_FOR_TARGET="$NEWLIB_CFLAGS" \
	CXXFLAGS_FOR_TARGET="$NEWLIB_CFLAGS" \
	--target=%{target}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# Conflicts with binutils
%{__rm} -r $RPM_BUILD_ROOT%{_infodir}

# The default pthread.h doesn't work right?
%{__rm} $RPM_BUILD_ROOT%{_prefix}/%{target}/include/pthread.h
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_prefix}/%{target}/include/

# We have to hack up libc.a to get things working.
# 32bit
mv $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/32/libc.a $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/32/libcrt_common.a
sed "s/@OBJFORMAT@/elf32-nacl/" newlib-libc-script > $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/32/libc.a

# 64bit (default)
mv $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/libc.a $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/libcrt_common.a
sed "s/@OBJFORMAT@/elf64-nacl/" newlib-libc-script > $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/libc.a

# fix copies to be hardlinks (maybe should symlink in the future)
findup -m $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_datadir}/iconv_data
%{_prefix}/%{target}/include
%{_prefix}/%{target}/lib
%changelog
* Wed Aug 01 2012 Elan Ruusamäe <glen@delfi.ee> 78a56c9
up to git 67e3510, nacl-headers-21.0.1180.57

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> ead93dd
- add nacl_trunk variable

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> ad4b851
- update also newlib-libc-script and pthread.h

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> aa022c0
- update from svn

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> 555495c
- up to 1.20.0 (git 096a72b), use chrome 20.0.1132.47 headers
  referred from chromium-browser-20.0.1132.47/src/native_client/tools/REVISIONS
  NACL_NEWLIB_COMMIT=096a72b929e8e5c153a599b607503e33b64e2a08

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> 74e1681
- script to get source

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> d66e5b3
- up to 590577e, tarballs from
  nacl-newlib-1.18.0-2.git590577e.fc17.src.rpm

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> 91b4de5
- use hardlinks for duplicate content

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> a6a083c
- new, based on spot's src.rpm:
  http://repos.fedorapeople.org/repos/spot/chromium-stable/fedora-16/SRPMS/nacl-newlib-1.18.0-1.gitf5185a57.fc16.src.rpm

